## davix 0.8.10

=== CMakeLists.txt ===
#-------------------------------------------------------------------------------
# Initialize
#-------------------------------------------------------------------------------
cmake_minimum_required (VERSION 3.0)
project (davix)

#-------------------------------------------------------------------------------
# Find the python executable to use during the build
#-------------------------------------------------------------------------------
find_package(Python COMPONENTS Interpreter REQUIRED)

#-------------------------------------------------------------------------------
# Regenerate include/davix/features.hpp and version.cmake at _build_ time
#-------------------------------------------------------------------------------
add_custom_target(GenerateVersionInfo ALL DEPENDS Version)
add_custom_command(
  OUTPUT Version
  COMMAND ${Python_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/genversion.py --template include/davix/features.hpp.in --out include/davix/features.hpp
  COMMAND ${Python_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/genversion.py --template version.cmake.in --out version.cmake
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
)

#-------------------------------------------------------------------------------
# Regenerate version.cmake at _configure_ time. Important since the above
# only regenerates it at compile time.
#-------------------------------------------------------------------------------
execute_process(
  COMMAND ${Python_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/genversion.py --template version.cmake.in --out version.cmake
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
)

#-------------------------------------------------------------------------------
# Include version.cmake. Whenever the version changes, ie you commit or tag,
# the following happens:
# - Next time you run 'make', version.cmake is updated.
# - The next 'make' will detect version.cmake was changed, and cmake will
#   reconfigure itself.
#
# A bit hacky.
#-------------------------------------------------------------------------------
include(${CMAKE_CURRENT_SOURCE_DIR}/release.cmake REQUIRED)
include(${CMAKE_CURRENT_SOURCE_DIR}/version.cmake OPTIONAL)
message("Configuring cmake for davix version: ${VERSION_FULL}")

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/modules/")
option(SHARED_LIBRARY "generate shared library" TRUE)
option(STATIC_LIBRARY  "generate static library" FALSE)


# build type
if(NOT CMAKE_BUILD_TYPE)
    message(STATUS "No build type selected, default to RelWithDebInfo")
    set(CMAKE_BUILD_TYPE "RelWithDebInfo")
endif(NOT CMAKE_BUILD_TYPE)

# load module
include(DefineInstallationPaths REQUIRED)
include(ReleaseDebugAutoFlags REQUIRED)
include(CMakeGeneratePkgConfig REQUIRED)
include(MacroAddDoxygen REQUIRED)
include(CMakeCXX11Support REQUIRED)
include(PortabilityGNUCheck REQUIRED)


set(OUTPUT_NAME_DAVIX "davix")

# components
option(ENABLE_TOOLS "enable or disable tools " TRUE)
option(ENABLE_HTML_DOCS "enable or disable generation of HTML documentation" FALSE)
option(EMBEDDED_LIBCURL "Use embedded libcurl" TRUE)
option(EMBEDDED_RAPIDJSON "Use embedded RapidJson" TRUE)
option(LIBCURL_BACKEND_BY_DEFAULT "Use libcurl by default" FALSE)

# features
option(ENABLE_IPV6 "enable or disable IPv6 support " TRUE)
option(ENABLE_TCP_NODELAY "enable or disable tcp_nodelay" TRUE)
option(ENABLE_THIRD_PARTY_COPY "enable or disable third party copy support" FALSE)

# tests
option(BENCH_TESTS "enable or disable the bench tests" FALSE)
option(DAVIX_TESTS "Flag to disable the building of all tests" TRUE)

# libs checks
find_package(Threads)

# openssl
find_package(OpenSSL)
SET(LIBSSL_PKG_LIBRARIES "${OPENSSL_LIBRARIES}")
SET(LIBSSL_PKG_INCLUDE_DIRS "${OPENSSL_INCLUDE_DIR}")

find_package(LibXml2)
set(LIBXML2_INCLUDE_DIRS ${LIBXML2_INCLUDE_DIR})

#const
set(HAVE_OPENSSL 1)
set(NE_HAVE_SSL 1)

add_subdirectory(deps)

# RapidJson library
if(EMBEDDED_RAPIDJSON)
  message(STATUS "Using bundled RapidJSON")
  set(RAPIDJSON_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/src/libs)
else()
  find_package(RapidJSON REQUIRED)
  set(RAPIDJSON_INCLUDE_DIRS ${RapidJSON_INCLUDE_DIRS})
endif()

#libuuid
if(NOT APPLE)
  find_package(uuid)
endif()

## general defs
add_definitions( -D_GNU_SOURCE)              # GNU source, import LFS, etc...
add_definitions( -D__DAVIX_INSIDE__)         # protection flag
add_definitions( -D__STDC_LIMIT_MACROS )     # C99 limit macros

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CXX11_FLAG_ENABLE}")

#-------------------------------------------------------------------------------
# Are we using system, or embedded libcurl?
#-------------------------------------------------------------------------------
if(EMBEDDED_LIBCURL)
  include(buildCurl REQUIRED)
  buildCurl()
  set(libcurl libcurl)
else()
  find_package(CURL REQUIRED)
  set(libcurl CURL::libcurl)
endif()

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/deps/libneon/src/ ${UUID_INCLUDE_DIRS})
include_directories(${CMAKE_SOURCE_DIR}/include/davix)

include(CTest)

add_subdirectory (src)
add_subdirectory (doc)

if(EXISTS "${CMAKE_SOURCE_DIR}/dist/CMakeLists.txt")
  add_subdirectory (dist)
endif()

if(DAVIX_TESTS)
  add_subdirectory (test)
endif()

#############################################################################
## headers
configure_file("${CMAKE_SOURCE_DIR}/include/davix/features.hpp.in"
               "${CMAKE_SOURCE_DIR}/include/davix/features.hpp"
               @ONLY)

install(DIRECTORY ${CMAKE_SOURCE_DIR}/include/davix/
        DESTINATION ${INCLUDE_INSTALL_DIR}/davix
        PATTERN "*.in" EXCLUDE)

##############################################################################
## Doc file
install(FILES RELEASE-NOTES.md LICENSE
                DESTINATION ${DOC_INSTALL_DIR}/) # install release notes


#######################################################
# Configure an 'uninstall' target
CONFIGURE_FILE(
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
  IMMEDIATE @ONLY)

# ADD_CUSTOM_TARGET(uninstall
#   "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

=== deps/CMakeLists.txt ===
###
## compile dependencies of davix

add_subdirectory(libneon)

=== doc/CMakeLists.txt ===



file(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/build/html/")

if(ENABLE_HTML_DOCS)
  addDoxyGeneration("Doxyfile.in")
  add_custom_target(doc DEPENDS)
  add_dependencies(doc doxygen)

  SET( l_doc "${CMAKE_CURRENT_BINARY_DIR}/build/html/")
  install(DIRECTORY ${l_doc} DESTINATION ${DOC_INSTALL_DIR}/html)
endif(ENABLE_HTML_DOCS)

FILE(GLOB man1_page ${CMAKE_CURRENT_SOURCE_DIR}/man/*.1)
install(FILES ${man1_page}
                        DESTINATION ${MAN_INSTALL_DIR}/man1/)

FILE(GLOB man3_page ${CMAKE_CURRENT_SOURCE_DIR}/man/*.3)
install(FILES ${man3_page}
                        DESTINATION ${MAN_INSTALL_DIR}/man3/)

=== src/CMakeLists.txt ===
# main file for src

set(DAVIX_SOURCES

  auth/davix_openssl.cpp
  auth/davixauth.cpp
  auth/davixx509cred_internal.hpp                        auth/davixx509cred.cpp

  backend/BackendRequest.hpp                             backend/BackendRequest.cpp
  backend/SessionFactory.hpp                             backend/SessionFactory.cpp
  backend/StandaloneNeonRequest.hpp                      backend/StandaloneNeonRequest.cpp

  core/ContentProvider.hpp                               core/ContentProvider.cpp
  core/RedirectionResolver.hpp                           core/RedirectionResolver.cpp
  core/SessionPool.hpp

  curl/CurlSession.hpp                                   curl/CurlSession.cpp
  curl/CurlSessionFactory.hpp                            curl/CurlSessionFactory.cpp
  curl/HeaderlineParser.hpp                              curl/HeaderlineParser.cpp
  curl/ResponseBuffer.hpp                                curl/ResponseBuffer.cpp
  curl/StandaloneCurlRequest.hpp                         curl/StandaloneCurlRequest.cpp

                                                         deprecated/httpcachetoken.cpp
                                                         file/davfile.cpp
                                                         file/davposix.cpp
  fileops/azure_meta_ops.hpp
  fileops/AzureIO.hpp                                    fileops/AzureIO.cpp
  fileops/chain_factory.hpp                              fileops/chain_factory.cpp
  fileops/davix_reliability_ops.hpp                      fileops/davix_reliability_ops.cpp
  fileops/davmeta.hpp                                    fileops/davmeta.cpp
  fileops/fileutils.hpp                                  fileops/fileutils.cpp
  fileops/httpiochain.hpp                                fileops/httpiochain.cpp
  fileops/httpiovec.hpp                                  fileops/httpiovec.cpp
  fileops/iobuffmap.hpp                                  fileops/iobuffmap.cpp
  fileops/S3IO.hpp                                       fileops/S3IO.cpp
  fileops/SwiftIO.hpp                                    fileops/SwiftIO.cpp

                                                         hooks/davix_hooks.cpp

                                                         libs/alibxx/chrono/timepoint.cpp
                                                         libs/alibxx/crypto/base64.cpp
                                                         libs/alibxx/crypto/hmacsha.cpp
                                                         libs/alibxx/str/format.cpp

  libs/datetime/datetime_utils.hpp                       libs/datetime/datetime_utils.cpp

  modules/modules_profiles.hpp                           modules/modules_profiles.cpp
  neon/neonrequest.hpp                                   neon/neonrequest.cpp
  neon/neonsession.hpp                                   neon/neonsession.cpp
  neon/neonsessionfactory.hpp                            neon/neonsessionfactory.cpp
                                                         params/davixrequestparams.cpp
                                                         request/httprequest.cpp
  status/DavixStatus.hpp                                 status/DavixStatus.cpp
                                                         status/davixstatusrequest.cpp

  utils/checksum_extractor.hpp                           utils/checksum_extractor.cpp
  utils/CompatibilityHacks.hpp                           utils/CompatibilityHacks.cpp
                                                         utils/davix_azure_utils.cpp
  utils/davix_fileproperties.hpp
                                                         utils/davix_gcloud_utils.cpp
  utils/davix_logger_internal.hpp                        utils/davix_logger.cpp
                                                         utils/davix_misc_utils.cpp
  utils/davix_utils_internal.hpp                         utils/davix_s3_utils.cpp
                                                         utils/davix_swift_utils.cpp
  utils/simple_get_pass.h                                utils/simple_get_pass.cpp
  utils/stringutils.hpp                                  utils/stringutils.cpp

                                                         utils/davixuri.cpp
  xml/azurepropparser.hpp                                xml/azurepropparser.cpp
  xml/davdeletexmlparser.hpp                             xml/davdeletexmlparser.cpp
  xml/davix_ptree.hpp                                    xml/davix_ptree.cpp
  xml/davpropxmlparser.hpp                               xml/davpropxmlparser.cpp
  xml/davxmlparser.hpp                                   xml/davxmlparser.cpp
  xml/metalinkparser.hpp                                 xml/metalinkparser.cpp
  xml/s3deleteparser.hpp                                 xml/s3deleteparser.cpp
  xml/S3MultiPartInitiationParser.hpp                    xml/S3MultiPartInitiationParser.cpp
  xml/s3propparser.hpp                                   xml/s3propparser.cpp
  xml/swiftpropparser.hpp                                xml/swiftpropparser.cpp

  davixcontext.cpp
  $<TARGET_OBJECTS:LibNeonObjects>
)

set(DAVIX_INTERNAL_INCLUDES
  ${OPENSSL_INCLUDE_DIR}
  ${LIBXML2_INCLUDE_DIR}
  ${RAPIDJSON_INCLUDE_DIRS}
  ${PROJECT_SOURCE_DIR}/deps
  ${PROJECT_SOURCE_DIR}/src
  ${CMAKE_CURRENT_BINARY_DIR}
)

configure_file(davix_internal_config.in ${CMAKE_CURRENT_BINARY_DIR}/davix_internal_config.hpp @ONLY)

add_subdirectory(modules/copy)

if(ENABLE_TOOLS)
  add_subdirectory(tools)
endif()

set(SECURE_TRANSPORT_LIBRARIES "")
if(APPLE)
  set(SECURE_TRANSPORT_LIBRARIES "-framework CoreFoundation -framework Security")
endif()

if(SHARED_LIBRARY)
add_library(libdavix  SHARED ${DAVIX_SOURCES} )

target_include_directories(libdavix PRIVATE ${DAVIX_INTERNAL_INCLUDES} )
target_link_libraries(libdavix
  PRIVATE ${libcurl}
  PUBLIC ${LIBSSL_PKG_LIBRARIES}
         ${LIBXML2_LIBRARIES}
         ${CMAKE_THREAD_LIBS_INIT}
         ${CMAKE_DL_LIBS}
         ${UUID_LIBRARIES}
         z
         ${SECURE_TRANSPORT_LIBRARIES}
)

set_target_properties(libdavix PROPERTIES
                            VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}
                            SOVERSION ${VERSION_MAJOR}
                            LINK_INTERFACE_LIBRARIES ""
                            INTERFACE_LINK_LIBRARIES ""
                            CLEAN_DIRECT_OUTPUT 1
                            OUTPUT_NAME ${OUTPUT_NAME_DAVIX})

install(TARGETS libdavix DESTINATION ${LIB_INSTALL_DIR} )

add_PkgConfigFile_for_Library("davix.pc" libdavix
                               HEADER_DIRS "davix"
                               CFLAGS " -D_FILE_OFFSET_BITS=64 "
                               DESCRIPTION "Libdavix, IO library for HTTP based protocols"
                               )
#install pkgconfig
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/davix.pc
        DESTINATION ${PKGCONFIG_FILES_DIR} )

endif(SHARED_LIBRARY)



if(STATIC_LIBRARY)

add_library(libdavix_static  STATIC ${DAVIX_SOURCES})
set_target_properties(libdavix_static PROPERTIES
                            OUTPUT_NAME ${OUTPUT_NAME_DAVIX})
target_include_directories(libdavix_static PRIVATE ${DAVIX_INTERNAL_INCLUDES} )

target_link_libraries(libdavix_static
  PRIVATE ${libcurl}
  PUBLIC  ${LIBSSL_PKG_LIBRARIES}
          ${LIBXML2_LIBRARIES}
          ${CMAKE_THREAD_LIBS_INIT}
          ${CMAKE_DL_LIBS}
          ${UUID_LIBRARIES}
          z
          ${SECURE_TRANSPORT_LIBRARIES}
)


add_library(libdavix ALIAS libdavix_static)

install(TARGETS libdavix_static DESTINATION ${LIB_INSTALL_DIR} )

endif(STATIC_LIBRARY)

=== test/CMakeLists.txt ===
# main file for src

find_package(GTest REQUIRED)

# force RPATH usage for easy test execution
set(CMAKE_SKIP_RPATH OFF
    CACHE BOOL "" FORCE)

include_directories(${PROJECT_SOURCE_DIR}/src ${PROJECT_BINARY_DIR}/src/)
link_directories(${PROJECT_BINARY_DIR}/src/)

set(TEST_CRED_PATH "${CMAKE_CURRENT_SOURCE_DIR}/certs/my_keycert.p12")
set(TEST_CRED_PASS "testpass")

add_subdirectory(unit)
add_subdirectory(slow-unit)
add_subdirectory(functional)
add_subdirectory(root-tests)
add_subdirectory(bench)

=== deps/libneon/CMakeLists.txt ===
project(libneon-tuned)
cmake_minimum_required (VERSION 3.0)
# main file for src

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/modules/")

# load module
include(ReleaseDebugAutoFlags REQUIRED)
include(PortabilityGNUCheck REQUIRED)
set(OUTPUT_NAME_DAVIX "neon")
set(VERSION_MAJOR 0)
set(VERSION_MINOR 0)
set(VERSION_PATCH 29)
set(VERSION_STRING ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH})

set(HAVE_LIBXML 1)
set(HAVE_IPV6 ${ENABLE_IPV6})
set(TCP_NODELAY ${ENABLE_TCP_NODELAY})

configure_file(config.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/config.h @ONLY)

add_library(LibNeonObjects OBJECT
  src/ne_207.c
  src/ne_acl3744.c
  src/ne_alloc.c
  src/ne_auth.c
  src/ne_basic.c
  src/ne_compress.c
  src/ne_dates.c
  src/ne_i18n.c
  src/ne_locks.c
  src/ne_md5.c
  src/ne_ntlm.c
  src/ne_oldacl.c
  src/ne_pkcs11.c
  src/ne_props.c
  src/ne_redirect.c
  src/ne_request.c
  src/ne_session.c
  src/ne_socket.c
  src/ne_socks.c
  src/ne_sspi.c
  src/ne_string.c
  src/ne_uri.c
  src/ne_utils.c
  src/ne_xml.c
  src/ne_xmlreq.c
  src/ne_openssl.c
)

target_compile_options(LibNeonObjects PRIVATE
  -std=gnu99 -fPIC -DNEON_VERSION="${VERSION_STRING}"
  -DNE_VERSION_MAJOR=${VERSION_MAJOR} -DNE_VERSION_MINOR=${VERSION_MINOR}
  -Wno-unused-parameter -fvisibility=hidden
)

target_include_directories(LibNeonObjects
  PRIVATE ${LIBXML2_INCLUDE_DIR}
          ${CMAKE_CURRENT_SOURCE_DIR}
          ${CMAKE_CURRENT_BINARY_DIR}
          ${CMAKE_CURRENT_SOURCE_DIR}/../
          ${OPENSSL_INCLUDE_DIR}
)

=== test/functional/CMakeLists.txt ===
# main file for src


set(src_davix_test_lib "davix_test_lib.cpp")

#set( src_test_req "test_request.cpp")
#set( src_test_checksum "test_checksum.cpp")
#set( src_test_stat_session "test_stat_session.cpp")
#set( src_test_rw "davix_rw_test.cpp")
#set( src_test_opendir "test_opendir.cpp")
#set( src_test_opendir_partial "test_opendir_partial.cpp")
#set( src_test_opendirpp "test_opendirpp.cpp")
#set( src_test_directory "test_directory.cpp")
#set( src_test_auto_stat_mkdir_check "test_auto_stat_mkdir_check.cpp")
#set( src_test_auto_rmdir_unlink_delete "test_auto_rmdir_unlink_delete.cpp")
#set( src_test_valid_read_generic_simple "test_valid_read_generic_simple.cpp")
#set( src_test_valid_write_read_generic_simple "test_valid_write_read_generic_simple.cpp")
#set( src_test_valid_write_read_fd "test_valid_write_read_fd.cpp")
#set( src_test_valid_write_read_vector_simple "test_valid_write_read_vector_simple.cpp")
#set( src_tool_read_vector_simple "tool_read_vector_simple.cpp")
#set( src_tool_get_replicas "tool_get_replica_simple.cpp")
#set( src_test_mv "test_mv.cpp")

add_library(test_davix_functional_lib STATIC ${src_davix_test_lib})

#add_executable(test_request ${src_test_req} )
#target_link_libraries(test_request libdavix  test_davix_functional_lib)

#add_executable(tool_read_vector_simple ${src_tool_read_vector_simple} )
#target_link_libraries(tool_read_vector_simple libdavix test_davix_functional_lib )

#add_executable(test_rw_fd ${src_test_valid_write_read_fd})
#target_link_libraries(test_rw_fd libdavix test_davix_functional_lib )

#add_executable(test_stat_auto_check ${src_test_auto_stat_mkdir_check})
#target_link_libraries(test_stat_auto_check libdavix test_davix_functional_lib)

#add_executable(test_checksum ${src_test_checksum})
#target_link_libraries(test_checksum libdavix test_davix_functional_lib)

#add_executable(test_auto_rmdir_unlink_delete ${src_test_auto_rmdir_unlink_delete})
#target_link_libraries(test_auto_rmdir_unlink_delete libdavix test_davix_functional_lib)

#add_executable(test_stat_session ${src_test_stat_session})
#target_link_libraries(test_stat_session libdavix test_davix_functional_lib)


#add_executable(test_rw ${src_test_rw})
#target_link_libraries(test_rw libdavix test_davix_functional_lib)

#add_executable(test_opendir ${src_test_opendir} )
#target_link_libraries(test_opendir libdavix test_davix_functional_lib)


#add_executable(test_directory ${src_test_directory} )
#target_link_libraries(test_directory libdavix test_davix_functional_lib)

#add_executable(test_opendir_partial ${src_test_opendir_partial})
#target_link_libraries(test_opendir_partial libdavix test_davix_functional_lib)

#add_executable(test_opendirpp ${src_test_opendirpp})
#target_link_libraries(test_opendirpp libdavix test_davix_functional_lib)

#add_executable(test_valid_read_generic_simple ${src_test_valid_read_generic_simple})
#target_link_libraries(test_valid_read_generic_simple libdavix test_davix_functional_lib)

#add_executable(test_valid_write_read_generic_simple ${src_test_valid_write_read_generic_simple})
#target_link_libraries(test_valid_write_read_generic_simple libdavix test_davix_functional_lib)

#add_executable(test_valid_write_read_vector_simple ${src_test_valid_write_read_vector_simple})
#target_link_libraries(test_valid_write_read_vector_simple libdavix test_davix_functional_lib)


#add_executable(tool_get_replicas ${src_tool_get_replicas})
#target_link_libraries(tool_get_replicas libdavix test_davix_functional_lib)

#add_executable(test_mv ${src_test_mv})
#target_link_libraries(test_mv libdavix test_davix_functional_lib)

add_executable(davix-tester ../TestcaseHandler.cpp davix-tester.cpp)
target_link_libraries(davix-tester libdavix test_davix_functional_lib)

install(TARGETS davix-tester
  DESTINATION ${BIN_INSTALL_DIR}/)

### DEPRECATED, to remove soon

# function(test_dav_endpoint_ronly name cred)

#     add_test(test_stat_session_${name} test_stat_session ${cred} ${name} ${name} ${name} ${name} ${name} ${name} ${name})
#     add_test(test_opendir_${name} test_opendir ${name} ${cred})
#   #  add_test(test_opendir_c_${name} test_opendir_c ${name} ${cred})
#     add_test(test_opendirpp_${name} test_opendirpp ${name} ${cred})
#   #  add_test(test_stat_c_${name} test_stat_c ${name} ${cred})
# endfunction(test_dav_endpoint_ronly name cred)

# function(test_dav_endpoint_rw name cred)

#     add_test(test_stat_session_${name} test_stat_session ${cred} ${name} ${name} ${name} ${name} ${name} ${name} ${name})
#     add_test(test_opendir_${name} test_opendir ${name} ${cred})
#     add_test(test_opendirpp_${name} test_opendirpp ${name} ${cred})
#     add_test(test_stat_auto_check_${name} test_stat_auto_check ${name} ${cred})
# endfunction(test_dav_endpoint_rw name cred)

# function(listdir_partial name size cred)
#     add_test(test_opendir_partial_${name}  test_opendir_partial ${name} ${size} ${cred})
# endfunction(listdir_partial name size cred)


# function(test_collection name cred)
#     add_test(test_directory_${name} test_directory ${name} ${cred})
# endfunction(test_collection name cred)

# function(test_valid_read_generic url cred)
#     add_test(test_valid_read_generic_${url} test_valid_read_generic_simple ${url} ${cred})
# endfunction(test_valid_read_generic url cred)

# function(test_valid_delete_all url cred)
#     add_test(test_auto_rmdir_unlink_delete_${url} test_auto_rmdir_unlink_delete ${url} ${cred})
# endfunction(test_valid_delete_all url cred)


# function(test_valid_write_read_generic url cred)
#     add_test(test_valid_write_read_generic_simple_${url} test_valid_write_read_generic_simple ${url} ${cred})
#     add_test(test_rw_fd_${url} test_rw_fd ${url} ${cred})
#     add_test(test_valid_write_read_vector_simple_${url} test_valid_write_read_vector_simple ${url} ${cred})
# endfunction(test_valid_write_read_generic url cred)

# function(test_replica_listing_existing url cred)
#    add_test(tool_get_replicas_${url} tool_get_replicas ${url} ${cred})
# endfunction(test_replica_listing_existing url cred)

# function(test_rename url cred)
#     add_test(test_mv_${url} test_mv ${url} ${cred})
# endfunction(test_rename url cred)

=== test/slow-unit/CMakeLists.txt ===
#-------------------------------------------------------------------------------
# Make gtest / gmock available for all targets that need it
#-------------------------------------------------------------------------------
set(BUILD_SHARED_LIBS OFF)

add_executable(davix-slow-unit-tests
  ../drunk-server/ConnectionInitiator.cpp
  ../drunk-server/DrunkServer.cpp
  ../drunk-server/Interactors.cpp
  ../drunk-server/LineReader.cpp

  drunk-server.cpp
  standalone-request.cpp
)

target_include_directories(davix-slow-unit-tests PRIVATE
  ${PROJECT_SOURCE_DIR}/src
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${GTEST_INCLUDE_DIRS}
)

target_link_libraries(davix-slow-unit-tests
  davix_tool_lib
  libdavix
  GTest::GTest
  GTest::Main
  ${CMAKE_THREAD_LIBS_INIT}
  ${LIBSSL_PKG_LIBRARIES}
)

add_test(slow-unit-tests davix-slow-unit-tests)

=== test/unit/CMakeLists.txt ===
#-------------------------------------------------------------------------------
# Make gtest / gmock available for all targets that need it
#-------------------------------------------------------------------------------
set(BUILD_SHARED_LIBS OFF)

add_definitions( -DTEST_VALID_CERT="${TEST_CRED_PATH}" -DTEST_VALID_CERT_PASS="${TEST_CRED_PASS}")

add_executable(davix-unit-tests
  ../drunk-server/DrunkServer.cpp

  cache.cpp
  chrono.cpp
  config-parser.cpp
  content-provider.cpp
  context.cpp
  datetime.cpp
  digest-extractor.cpp
  gcloud.cpp
  metalink-replica.cpp
  neon.cpp
  parser.cpp
  response-buffer.cpp
  session-factory.cpp
  session.cpp
  status.cpp
  testcert.cpp
  typeconv.cpp
  utils.cpp
  xml-parser.cpp
)

target_include_directories(davix-unit-tests PRIVATE
  ${PROJECT_SOURCE_DIR}/src
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${GTEST_INCLUDE_DIRS}
)

target_link_libraries(davix-unit-tests
  davix_tool_lib
  libdavix
  GTest::GTest
  GTest::Main
  ${CMAKE_THREAD_LIBS_INIT}
  ${LIBSSL_PKG_LIBRARIES}
)

install(TARGETS davix-unit-tests
  DESTINATION ${BIN_INSTALL_DIR}/)

add_test(unit-tests davix-unit-tests)

=== deps/curl/lib/CMakeLists.txt ===
set(LIB_NAME libcurl)

if(BUILD_SHARED_LIBS)
  set(CURL_STATICLIB NO)
else()
  set(CURL_STATICLIB YES)
endif()

# Use:
# * CURL_STATICLIB
configure_file(curl_config.h.cmake
  ${CMAKE_CURRENT_BINARY_DIR}/curl_config.h)

transform_makefile_inc("Makefile.inc" "${CMAKE_CURRENT_BINARY_DIR}/Makefile.inc.cmake")
include(${CMAKE_CURRENT_BINARY_DIR}/Makefile.inc.cmake)

list(APPEND HHEADERS
  ${CMAKE_CURRENT_BINARY_DIR}/curl_config.h
  )

if(MSVC)
  list(APPEND CSOURCES libcurl.rc)
endif()

# SET(CSOURCES
# #  memdebug.c -not used
# # nwlib.c - Not used
# # strtok.c - specify later
# # strtoofft.c - specify later
# )

# # if we have Kerberos 4, right now this is never on
# #OPTION(CURL_KRB4 "Use Kerberos 4" OFF)
# IF(CURL_KRB4)
# SET(CSOURCES ${CSOURCES}
# krb4.c
# security.c
# )
# ENDIF(CURL_KRB4)

# #OPTION(CURL_MALLOC_DEBUG "Debug mallocs in Curl" OFF)
# MARK_AS_ADVANCED(CURL_MALLOC_DEBUG)
# IF(CURL_MALLOC_DEBUG)
# SET(CSOURCES ${CSOURCES}
# memdebug.c
# )
# ENDIF(CURL_MALLOC_DEBUG)

# # only build compat strtoofft if we need to
# IF(NOT HAVE_STRTOLL AND NOT HAVE__STRTOI64)
# SET(CSOURCES ${CSOURCES}
# strtoofft.c
# )
# ENDIF(NOT HAVE_STRTOLL AND NOT HAVE__STRTOI64)


# The rest of the build

include_directories(${CMAKE_CURRENT_BINARY_DIR}/../include)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/..)
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../include)
include_directories(${CMAKE_CURRENT_BINARY_DIR}/..)
include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${CMAKE_CURRENT_BINARY_DIR})
if(USE_ARES)
  include_directories(${CARES_INCLUDE_DIR})
endif()

add_library(
  ${LIB_NAME}
  ${HHEADERS} ${CSOURCES}
  )

if(MSVC AND NOT BUILD_SHARED_LIBS)
  set_target_properties(${LIB_NAME} PROPERTIES STATIC_LIBRARY_FLAGS ${CMAKE_EXE_LINKER_FLAGS})
endif()

if(NOT BUILD_SHARED_LIBS)
    set_target_properties(${LIB_NAME} PROPERTIES INTERFACE_COMPILE_DEFINITIONS CURL_STATICLIB)
endif()

target_link_libraries(${LIB_NAME} ${CURL_LIBS})

if(WIN32)
  add_definitions(-D_USRDLL)
endif()

set_target_properties(${LIB_NAME} PROPERTIES COMPILE_DEFINITIONS BUILDING_LIBCURL)

if(HIDES_CURL_PRIVATE_SYMBOLS)
  set_property(TARGET ${LIB_NAME} APPEND PROPERTY COMPILE_DEFINITIONS "CURL_HIDDEN_SYMBOLS")
  set_property(TARGET ${LIB_NAME} APPEND PROPERTY COMPILE_FLAGS ${CURL_CFLAG_SYMBOLS_HIDE})
endif()

# Remove the "lib" prefix since the library is already named "libcurl".
set_target_properties(${LIB_NAME} PROPERTIES PREFIX "")
set_target_properties(${LIB_NAME} PROPERTIES IMPORT_PREFIX "")

if(CURL_HAS_LTO)
  set_target_properties(${LIB_NAME} PROPERTIES
    INTERPROCEDURAL_OPTIMIZATION_RELEASE TRUE
    INTERPROCEDURAL_OPTIMIZATION_RELWITHDEBINFO TRUE)
endif()

if(WIN32)
  if(BUILD_SHARED_LIBS)
    # Add "_imp" as a suffix before the extension to avoid conflicting with the statically linked "libcurl.lib"
    set_target_properties(${LIB_NAME} PROPERTIES IMPORT_SUFFIX "_imp.lib")
  endif()
endif()

target_include_directories(${LIB_NAME} INTERFACE
  $<INSTALL_INTERFACE:include>
  $<BUILD_INTERFACE:${CURL_SOURCE_DIR}/include>)

install(TARGETS ${LIB_NAME}
  EXPORT ${TARGETS_EXPORT_NAME}
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)

export(TARGETS ${LIB_NAME}
       APPEND FILE ${PROJECT_BINARY_DIR}/libcurl-target.cmake
       NAMESPACE CURL::
)

=== deps/curl/src/CMakeLists.txt ===
set(EXE_NAME curl)

if(USE_MANUAL)
  # Use the C locale to ensure that only ASCII characters appear in the
  # embedded text. NROFF and MANOPT are set in the parent CMakeLists.txt
  add_custom_command(
    OUTPUT tool_hugehelp.c
    COMMAND ${CMAKE_COMMAND} -E echo "#include \"tool_setup.h\"" > tool_hugehelp.c
    COMMAND ${CMAKE_COMMAND} -E echo "#ifndef HAVE_LIBZ" >> tool_hugehelp.c
    COMMAND env LC_ALL=C "${NROFF}" ${NROFF_MANOPT}
            "${CURL_BINARY_DIR}/docs/curl.1" |
            "${PERL_EXECUTABLE}" "${CMAKE_CURRENT_SOURCE_DIR}/mkhelp.pl" >> tool_hugehelp.c
    COMMAND ${CMAKE_COMMAND} -E echo "#else" >> tool_hugehelp.c
    COMMAND env LC_ALL=C "${NROFF}" ${NROFF_MANOPT}
            "${CURL_BINARY_DIR}/docs/curl.1" |
            "${PERL_EXECUTABLE}" "${CMAKE_CURRENT_SOURCE_DIR}/mkhelp.pl" -c >> tool_hugehelp.c
    COMMAND ${CMAKE_COMMAND} -E echo "#endif /* HAVE_LIBZ */" >> tool_hugehelp.c
    DEPENDS
      generate-curl.1
      "${CURL_BINARY_DIR}/docs/curl.1"
      "${CMAKE_CURRENT_SOURCE_DIR}/mkhelp.pl"
      "${CMAKE_CURRENT_SOURCE_DIR}/tool_hugehelp.h"
    VERBATIM)
else()
  add_custom_command(
    OUTPUT tool_hugehelp.c
    COMMAND ${CMAKE_COMMAND} -E echo "/* built-in manual is disabled, blank function */" > tool_hugehelp.c
    COMMAND ${CMAKE_COMMAND} -E echo "#include \"tool_hugehelp.h\"" >> tool_hugehelp.c
    COMMAND ${CMAKE_COMMAND} -E echo "void hugehelp(void) {}" >> tool_hugehelp.c
    DEPENDS
      "${CMAKE_CURRENT_SOURCE_DIR}/tool_hugehelp.h"
    VERBATIM)

endif()

transform_makefile_inc("Makefile.inc" "${CMAKE_CURRENT_BINARY_DIR}/Makefile.inc.cmake")
include(${CMAKE_CURRENT_BINARY_DIR}/Makefile.inc.cmake)

if(MSVC)
  list(APPEND CURL_FILES curl.rc)
endif()

# CURL_FILES comes from Makefile.inc
add_executable(
  ${EXE_NAME}
  ${CURL_FILES}
  )

if(CURL_HAS_LTO)
  set_target_properties(${EXE_NAME} PROPERTIES
    INTERPROCEDURAL_OPTIMIZATION_RELEASE TRUE
    INTERPROCEDURAL_OPTIMIZATION_RELWITHDEBINFO TRUE)
endif()

source_group("curlX source files" FILES ${CURLX_CFILES})
source_group("curl source files" FILES ${CURL_CFILES})
source_group("curl header files" FILES ${CURL_HFILES})

include_directories(
  ${CURL_SOURCE_DIR}/lib        # To be able to reach "curl_setup_once.h"
  ${CURL_BINARY_DIR}/lib        # To be able to reach "curl_config.h"
  ${CURL_BINARY_DIR}/include    # To be able to reach "curl/curl.h"
  # This is needed as tool_hugehelp.c is generated in the binary dir
  ${CURL_SOURCE_DIR}/src        # To be able to reach "tool_hugehelp.h"
  )

#Build curl executable
target_link_libraries(${EXE_NAME} libcurl ${CURL_LIBS})

################################################################################

#SET_TARGET_PROPERTIES(${EXE_NAME} ARCHIVE_OUTPUT_DIRECTORY "blah blah blah")
#SET_TARGET_PROPERTIES(${EXE_NAME} RUNTIME_OUTPUT_DIRECTORY "blah blah blah")
#SET_TARGET_PROPERTIES(${EXE_NAME} LIBRARY_OUTPUT_DIRECTORY "blah blah blah")

#INCLUDE(ModuleInstall OPTIONAL)

install(TARGETS ${EXE_NAME} EXPORT ${TARGETS_EXPORT_NAME} DESTINATION ${CMAKE_INSTALL_BINDIR})
export(TARGETS ${EXE_NAME}
       APPEND FILE ${PROJECT_BINARY_DIR}/curl-target.cmake
       NAMESPACE CURL::
)

=== deps/curl/tests/CMakeLists.txt ===
add_subdirectory(data)
add_subdirectory(libtest)
add_subdirectory(server)
add_subdirectory(unit)

=== debian/changelog ===
davix (0.8.10-2) unstable; urgency=medium

  * Update CMake minimum requirement and supported versions (Closes: #1112827)

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Wed, 17 Sep 2025 15:52:09 +0200

davix (0.8.10-1) unstable; urgency=medium

  * Update to version 0.8.10

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Thu, 13 Feb 2025 11:09:41 +0100

=== debian/control ===
Source: davix
Priority: optional
Maintainer: Mattias Ellert <mattias.ellert@physics.uu.se>
Build-Depends:
 debhelper-compat (= 13),
 dpkg-dev (>= 1.22.5),
 cmake,
 libxml2-dev,
 libssl-dev,
 gsoap,
 libgsoap-dev,
 libgtest-dev,
 libcurl4-openssl-dev,
 pkgconf,
 python3:native,
 zlib1g-dev,
 uuid-dev,
 rapidjson-dev
Build-Depends-Indep:
 dh-sequence-sphinxdoc,
 doxygen,
 python3-sphinx,
 python3-sphinx-rtd-theme
Standards-Version: 4.7.2
Section: net
Vcs-Browser: https://salsa.debian.org/ellert/davix
Vcs-Git: https://salsa.debian.org/ellert/davix.git
Homepage: https://dmc-docs.web.cern.ch/dmc-docs/davix.html

Package: davix
Architecture: any
Multi-Arch: foreign
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libdavix0t64 (= ${binary:Version})
Description: Toolkit for http based file management
 Davix is a toolkit designed for file operations with http based protocols
 (WebDav, Amazon S3, ...).

Package: davix-tests
Architecture: any
Multi-Arch: foreign
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libdavix0t64 (= ${binary:Version})
Description: Test suite for davix
 Test suite for davix. Davix is a toolkit designed for file operations
 with http based protocols (WebDav, Amazon S3, ...).

Package: libdavix0t64
Provides: ${t64:Provides}
X-Time64-Compat: libdavix0v5
Replaces: libdavix0v5
Breaks: libdavix0v5 (<< ${source:Version})
Section: libs
Architecture: any
Multi-Arch: same
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: Runtime library for davix
 Library for davix. Davix is a toolkit designed for file operations with
 http based protocols (WebDav, Amazon S3, ...).

Package: davix-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 libdavix0t64 (= ${binary:Version})
Description: Development files for davix
 Development files for davix. Davix is a toolkit designed for file operations
 with http based protocols (WebDav, Amazon S3, ...).

Package: davix-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 ${sphinxdoc:Depends}
Built-Using:
 ${sphinxdoc:Built-Using}
Description: Documentation for davix
 Documentation and examples for davix. Davix is a toolkit designed for file
 operations with http based protocols (WebDav, Amazon S3, ...).

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow

BUILD_DOC = $(if $(filter davix-doc,$(shell dh_listpackages)),TRUE,FALSE)

%:
	dh $@

override_dh_auto_configure:
	# Remove bundled stuff
	rm -rf deps/curl
	rm -rf src/libs/rapidjson
	rm -rf test/pywebdav
	rm -rf doc/sphinx/_themes/sphinx_rtd_theme
	dh_auto_configure -- -DLIB_SUFFIX:PATH="/$(DEB_HOST_MULTIARCH)" \
		-DEMBEDDED_LIBCURL:BOOL=FALSE \
		-DEMBEDDED_RAPIDJSON:BOOL=FALSE \
		-DENABLE_HTML_DOCS:BOOL=$(BUILD_DOC) \
		-DENABLE_THIRD_PARTY_COPY:BOOL=TRUE

override_dh_auto_build:
	dh_auto_build
	[ "$(BUILD_DOC)" = "FALSE" ] || ( dh_auto_build -- doc && ( \
	  cd obj-$(DEB_HOST_GNU_TYPE)/doc ; \
	  sphinx-build -q -b html ../../doc/sphinx build/html )	)

override_dh_auto_install:
	dh_auto_install
	rm debian/tmp/usr/share/doc/davix/LICENSE

override_dh_auto_test:
	dh_auto_test -- ARGS+="-V -T Test"
